% data dimensions
n = 512;
% timing repetitions
m = 1000;

A = gones(n);

% warm up
medfilt2_cpu(A);
medfilt2_gmem(A);
medfilt2_tex(A);
medfilt2_smem(A);
medfilt2_exch(A);

gforce % block
tic
  for i = 1:m
    medfilt2_cpu(A);
  end
gforce
cpu = toc / m

tic
  for i = 1:m
    medfilt2_gmem(A);
  end
gforce
gmem = toc / m

tic
  for i = 1:m
    medfilt2_tex(A);
  end
gforce
tex = toc / m

tic
  for i = 1:m
    medfilt2_smem(A);
  end
gforce
smem = toc / m

tic
  for i = 1:m
    medfilt2_exch(A);
  end
gforce
exch = toc / m

perf = [cpu/cpu cpu/gmem gmem/tex tex/smem smem/exch]';
perf_= cpu./[cpu gmem tex smem exch]';
[perf perf_]
